require 'active_support/all'

module HasVersions
  extend ActiveSupport::Autoload

  autoload :Record
  autoload :Version

  module Record
    extend ActiveSupport::Autoload

    autoload :Attributes
    autoload :Configuration
    autoload :Reset

    module Orm
      extend ActiveSupport::Autoload
      autoload :CassandraObject
    end
  end

  module Version
    extend ActiveSupport::Autoload

    autoload :Diff
    autoload :Log
  end
end

ActiveSupport.on_load :cassandra_object do
  extend HasVersions::Record::Orm::CassandraObject
end
