module HasVersions
  module Record
    module Reset
      extend ActiveSupport::Concern

      module ClassMethods
        def from_version(version)
          new.tap do |object|
            object.reset!(version)
          end
        end
      end

      def reset!(version)
        self.class.versioned_attributes.each do |attribute|
          value = self.class.versioning_decode_value(attribute, version.snapshot[attribute])
          send("#{attribute}=", value)
        end
        self
      end
    end
  end
end