module HasVersions
  module Version
    module Diff
      def diff(other = parent)
        diff_fetch(other) do
          other_snapshot = other.nil? ? {} : other.decoded_snapshot

          output = {}
          decoded_snapshot.each do |attribute, new_value|
            other_value = other_snapshot[attribute]

            if other_value != new_value
              output[attribute] = [other_value, new_value]
            end
          end

          output
        end
      end

      def applied_modifications(other)
        diff.keys - diff(other).keys
      end

      def unused_modifications(other)
        diff.keys & diff(other).keys
      end

      def decoded_snapshot
        @decoded_snapshot ||= begin
          decoded = {}
          target.class.versioned_attributes.each do |attribute|
            decoded[attribute] = target.class.versioning_decode_value(attribute, snapshot[attribute])#attribute.to_s#decode_attribute(attribute, snapshot[attribute])
          end
          decoded
        end
      end

      private

        def diff_fetch(other)
          @diff_cache ||= {}
          @diff_cache[other] ||= yield
        end
    end
  end
end
