module HasVersions
  module Version
    class LogCollection
      include Enumerable

      def initialize(version)
        @version = version
      end

      def walk
        walker = Walker.new(@version)
        while v = walker.next
          yield v
        end
      end
      alias_method :each, :walk

      def all
        all = []
        walk { |v| all << v }
        all
      end
      alias_method :to_a, :all

      class Walker
        attr_accessor :current_version
        def initialize(version)
          self.current_version = version
        end

        def next
          version = self.current_version
          self.current_version = version.try(:parent)
          version
        end
      end
    end

    module Log
      def log
        @log ||= LogCollection.new(self)
      end
    end
  end
end